﻿Imports System.ComponentModel
Imports System.Drawing.Printing
Imports System.IO
Imports Hartmann_Statistik.HartmannDts

Public Class Form1

#Region "Form"

    Private _dataPath As String = Path.GetFullPath("HartmannStatistik.xml")
    'Private _dataPath2 As String = Application.StartupPath("HartmannStats.xml")

    Private Sub DatenSpeichern()
        Me.Validate()
        If Not Me.Validate Then Return
        HartmannDts.WriteXml(_dataPath)
        HartmannDts.AcceptChanges()
    End Sub

    Private Sub DatenLaden()
        HartmannDts.Clear()
        For Each tb As DataTable In HartmannDts.Tables
            tb.BeginLoadData()
        Next
        If File.Exists(_dataPath) Then HartmannDts.ReadXml(_dataPath)
        For Each tb As DataTable In HartmannDts.Tables
            tb.EndLoadData()
        Next
        HartmannDts.EnforceConstraints = True
    End Sub

    Private Sub Form1_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        With Me
            If .DialogResult <> DialogResult.None Then Return
            .Validate()
            .SuspendLayout()
            With .Controls
                While .Count > 0 : .Item(.Count - 1).Dispose() : End While
            End With
        End With
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        If Not HartmannDts.HasChanges Then Return
        DatenSpeichern()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        DatenLaden()
        TabControl1.TabPages.Remove(TabPageVertriebsMA)
        TabControl1.TabPages.Remove(TabPageAuswertung)
        lblDatum.Text = Date.Today.ToShortDateString
        lblZeit.Text = DateTime.Now.ToShortTimeString
        AnzahlPlaeneAnzeigen()
    End Sub

    Private Sub MenuStrip_Click(sender As Object, e As EventArgs) Handles btnHome.Click, btnPlanAnlegen.Click, btnInfo.Click, btnVertriebsMAAnzeigen.Click, btnVertriebsMAAnlegen.Click, btnBeenden.Click, btnDatenLaden.Click, btnDatenSpeichern.Click, btnAuswertung.Click
        Select Case True
            Case sender Is btnDatenLaden : DatenLaden()
            Case sender Is btnDatenSpeichern : DatenSpeichern()
            Case sender Is btnVertriebsMAAnlegen : VertriebMAAnzeigen() : bsVertriebmitarbeiter.EditNew(Of dlgVertriebmitarbeiter)(True)
            Case sender Is btnVertriebsMAAnzeigen : VertriebMAAnzeigen()
            Case sender Is btnPlanAnlegen : bsPlan.EditNew(Of dlgPlan)(True)
            Case sender Is btnBeenden : Application.Exit()
            Case sender Is btnInfo : InfoAnzeigen()
            Case sender Is btnHome : TabControl1.SelectTab(TabPageUebersicht)
            Case sender Is btnAuswertung : AuswertungAnzeigen()
        End Select
    End Sub

#End Region

    Private Sub AnzahlPlaeneAnzeigen()
        For i = 0 To bsPlan.Count
            lblAnzahlPlaeneGesamt.Text = i.ToString
        Next
    End Sub

    Private Sub StripButtonDrucken_MouseHover(sender As Object, e As EventArgs) Handles StripButtonDrucken.MouseHover
        StripButtonDrucken.ShowDropDown()
    End Sub

    Private Sub InfoAnzeigen()
        Using frmInfo As New dlgInformation
            frmInfo.ShowDialog(Me)
        End Using
    End Sub

    Private Sub AuswertungAnzeigen()
        If TabControl1.Contains(TabPageAuswertung) = False Then
            TabControl1.TabPages.Add(TabPageAuswertung)
        End If
        TabControl1.SelectTab(TabPageAuswertung)
    End Sub

    Private Sub VertriebMAAnzeigen()
        If TabControl1.Contains(TabPageVertriebsMA) = False Then
            TabControl1.TabPages.Add(TabPageVertriebsMA)
        End If
        TabControl1.SelectTab(TabPageVertriebsMA)
    End Sub

    Private Sub TabPageVertriebsMA_Leave(sender As Object, e As EventArgs) Handles TabPageVertriebsMA.Leave
        TabControl1.TabPages.Remove(TabPageVertriebsMA)
    End Sub

    Private Sub PlanDataGridView_DoubleClick(sender As Object, e As EventArgs) Handles PlanDataGridView.DoubleClick
        bsPlan.EditCurrent(Of dlgPlan)()
    End Sub

    Private Sub VertriebmitarbeiterDataGridView_DoubleClick(sender As Object, e As EventArgs) Handles VertriebmitarbeiterDataGridView.DoubleClick
        bsVertriebmitarbeiter.EditCurrent(Of dlgVertriebmitarbeiter)()
    End Sub

    Private Sub btnKundenSuchen_Click(sender As Object, e As EventArgs) Handles btnKundenSuchen.Click
        KundenSuchen()
    End Sub
    Private Sub KundenSuchen()
        bsPlan.Filter = "[Einrichtungsname] like '%" & txtSuche.Text & "%'"
    End Sub

    Private Sub btnFilterReset_Click(sender As Object, e As EventArgs) Handles btnFilterReset.Click
        bsPlan.FilterX("")
        txtSuche.Text = ""
    End Sub

    Private Sub txtSuche_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtSuche.KeyPress
        KundenSuchen()
    End Sub

    Private Sub bsPlan_ListChanged(sender As Object, e As ListChangedEventArgs) Handles bsPlan.ListChanged
        AnzahlPlaeneAnzeigen()
    End Sub

#Region "Statistik"

    Private Sub TabpageAuswertung_Enter(sender As Object, e As EventArgs) Handles TabPageAuswertung.Enter
        cboJahrAuswertung.SelectedItem = "2017"
        lblSummeQuartal1.Text = 0.ToString("C2")
        lblSummeQuartal2.Text = 0.ToString("C2")
        lblSummeQuartal3.Text = 0.ToString("C2")
        lblSummeQuartal4.Text = 0.ToString("C2")
        lblUmsatzJanuar.Text = 0.ToString("C2")
        lblUmsatzFebruar.Text = 0.ToString("C2")
        lblUmsatzMaerz.Text = 0.ToString("C2")
        lblUmsatzApril.Text = 0.ToString("C2")
        lblUmsatzMai.Text = 0.ToString("C2")
        lblUmsatzJuni.Text = 0.ToString("C2")
        lblUmsatzJuli.Text = 0.ToString("C2")
        lblUmsatzAugust.Text = 0.ToString("C2")
        lblUmsatzSeptember.Text = 0.ToString("C2")
        lblUmsatzOktober.Text = 0.ToString("C2")
        lblUmsatzNovember.Text = 0.ToString("C2")
        lblUmsatzDezember.Text = 0.ToString("C2")
        lblUmsatzJahr.Text = 0.ToString("C2")
        Auswertung()
    End Sub

    Private Sub TabpageAuswertung_Leave(sender As Object, e As EventArgs) Handles TabPageAuswertung.Leave
        Me.Chart1.Series(0).Points.Clear()
        Me.Chart1.Series(1).Points.Clear()
        Me.Chart1.Series(2).Points.Clear()
        Me.Chart1.Series(3).Points.Clear()
        TabControl1.TabPages.Remove(TabPageAuswertung)
    End Sub

    Private Sub Auswertung()
        Me.Chart1.Series(0).Points.Clear()
        Me.Chart1.Series(1).Points.Clear()
        Me.Chart1.Series(2).Points.Clear()
        Me.Chart1.Series(3).Points.Clear()

        Dim plaene = HartmannDts.Plan
        Dim resultJanuar = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 1, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 1, 31)).Count
        Dim resultFebruar = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 2, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 2, 28)).Count
        Dim resultMaerz = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 3, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 3, 31)).Count
        Dim resultApril = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 4, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 4, 30)).Count
        Dim resultMai = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 5, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 5, 31)).Count
        Dim resultJuni = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 6, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 6, 30)).Count
        Dim resultJuli = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 7, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 7, 31)).Count
        Dim resultAugust = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 8, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 8, 31)).Count
        Dim resultSeptember = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 9, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 9, 30)).Count
        Dim resultOktober = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 10, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 10, 31)).Count
        Dim resultNovember = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 11, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 11, 30)).Count
        Dim resultDezember = (From a In plaene Where a.Uploaddatum >= New Date(CInt(cboJahrAuswertung.SelectedItem), 12, 1) And a.Uploaddatum <= New Date(CInt(cboJahrAuswertung.SelectedItem), 12, 31)).Count



        Me.Chart1.ChartAreas("1. Quartal").AxisY.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("1. Quartal").AxisX.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("2. Quartal").AxisX.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("2. Quartal").AxisY.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("3. Quartal").AxisY.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("3. Quartal").AxisX.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("4. Quartal").AxisX.MajorGrid.LineColor = Color.Gainsboro
        Me.Chart1.ChartAreas("4. Quartal").AxisY.MajorGrid.LineColor = Color.Gainsboro


        Me.Chart1.Series("1. Quartal").Points.AddXY("Jan", resultJanuar)
        Me.Chart1.Series("1. Quartal").Points.AddXY("Feb", resultFebruar)
        Me.Chart1.Series("1. Quartal").Points.AddXY("Mär", resultMaerz)
        Me.Chart1.Series("2. Quartal").Points.AddXY("Apr", resultApril)
        Me.Chart1.Series("2. Quartal").Points.AddXY("Mai", resultMai)
        Me.Chart1.Series("2. Quartal").Points.AddXY("Jun", resultJuni)
        Me.Chart1.Series("3. Quartal").Points.AddXY("Jul", resultJuli)
        Me.Chart1.Series("3. Quartal").Points.AddXY("Aug", resultAugust)
        Me.Chart1.Series("3. Quartal").Points.AddXY("Sep", resultSeptember)
        Me.Chart1.Series("4. Quartal").Points.AddXY("Okt", resultOktober)
        Me.Chart1.Series("4. Quartal").Points.AddXY("Nov", resultNovember)
        Me.Chart1.Series("4. Quartal").Points.AddXY("Dez", resultDezember)

        '**** Berechnung Quartal 1 ****
        Dim UmsatzJanuar As Double = (resultJanuar * 150) * 1.19
        lblUmsatzJanuar.Text = UmsatzJanuar.ToString("C2")
        Dim UmsatzFebruar As Double = (resultFebruar * 150) * 1.19
        lblUmsatzFebruar.Text = UmsatzFebruar.ToString("C2")
        Dim UmsatzMaerz As Double = (resultMaerz * 150) * 1.19
        lblUmsatzMaerz.Text = UmsatzMaerz.ToString("C2")

        Dim UmsatzQuartal1 As Double = UmsatzJanuar + UmsatzFebruar + UmsatzMaerz

        If UmsatzQuartal1 > 0 Then
            lblSummeQuartal1.ForeColor = Color.Green
        Else
            lblSummeQuartal1.ForeColor = Color.Red
        End If
        lblSummeQuartal1.Text = UmsatzQuartal1.ToString("C2")

        '**** Berechnung Quartal2 ****
        Dim UmsatzApril As Double = (resultApril * 150) * 1.19
        lblUmsatzApril.Text = UmsatzApril.ToString("C2")
        Dim UmsatzMai As Double = (resultMai * 150) * 1.19
        lblUmsatzMai.Text = UmsatzMai.ToString("C2")
        Dim UmsatzJuni As Double = (resultJuni * 150) * 1.19
        lblUmsatzJuni.Text = UmsatzJuni.ToString("C2")
        Dim UmsatzQuartal2 As Double = UmsatzApril + UmsatzMai + UmsatzJuni
        If UmsatzQuartal2 > 0 Then
            lblSummeQuartal2.ForeColor = Color.Green
        Else
            lblSummeQuartal2.ForeColor = Color.Red
        End If
        lblSummeQuartal2.Text = UmsatzQuartal2.ToString("C2")

        '**** Berechnung Quartal 3 ****
        Dim UmsatzJuli As Double = (resultJuli * 150) * 1.19
        lblUmsatzJuli.Text = UmsatzJuli.ToString("C2")
        Dim UmsatzAugust As Double = (resultAugust * 150) * 1.19
        lblUmsatzAugust.Text = UmsatzAugust.ToString("C2")
        Dim UmsatzSeptember As Double = (resultSeptember * 150) * 1.19
        lblUmsatzSeptember.Text = UmsatzSeptember.ToString("C2")
        Dim UmsatzQuartal3 As Double = UmsatzJuli + UmsatzAugust + UmsatzSeptember
        If UmsatzQuartal3 > 0 Then
            lblSummeQuartal3.ForeColor = Color.Green
        Else
            lblSummeQuartal3.ForeColor = Color.Red
        End If
        lblSummeQuartal3.Text = UmsatzQuartal3.ToString("C2")

        '**** Berechnung Quartal 4 ****
        Dim UmsatzOktober As Double = (resultOktober * 150) * 1.19
        lblUmsatzOktober.Text = UmsatzOktober.ToString("C2")
        Dim UmsatzNovember As Double = (resultNovember * 150) * 1.19
        lblUmsatzNovember.Text = UmsatzNovember.ToString("C2")
        Dim UmsatzDezember As Double = (resultDezember * 150) * 1.19
        lblUmsatzDezember.Text = UmsatzDezember.ToString("C2")
        Dim UmsatzQuartal4 As Double = UmsatzOktober + UmsatzNovember + UmsatzDezember
        If UmsatzQuartal4 > 0 Then
            lblSummeQuartal4.ForeColor = Color.Green
        Else
            lblSummeQuartal4.ForeColor = Color.Red
        End If
        lblSummeQuartal4.Text = UmsatzQuartal4.ToString("C2")

        Dim UmsatzJahr As Double = UmsatzQuartal1 + UmsatzQuartal2 + UmsatzQuartal3 + UmsatzQuartal4
        If UmsatzJahr > 0 Then
            lblUmsatzJahr.ForeColor = Color.Green
        End If
        lblUmsatzJahr.Text = UmsatzJahr.ToString("C2")
    End Sub

    Private Sub cboJahrAuswertung_SelectionChangeCommitted(sender As Object, e As EventArgs) Handles cboJahrAuswertung.SelectionChangeCommitted
        Auswertung()
    End Sub

#End Region

#Region "Drucken"

    Private Sub btnPrintMonatsStatistik_Click(sender As Object, e As EventArgs) Handles btnPrintMonatsStatistik.Click
        Using frmDruckenMonatsStatistik As New dlgDruckenMonatsStatistik
            frmDruckenMonatsStatistik.PlanBindingSource.DataSource = bsDruckenMonat
            If frmDruckenMonatsStatistik.ShowDialog(Me) = DialogResult.OK Then
                frmDruckenMonatsStatistik.PlanBindingSource.EndEdit()
            Else
                frmDruckenMonatsStatistik.PlanBindingSource.CancelEdit()
            End If
        End Using
    End Sub

    Private Sub btnPrintVertrieblerStatistik_Click(sender As Object, e As EventArgs) Handles btnPrintVertrieblerStatistik.Click
        Using frmDruckenVertrieblerStatistik As New dlgDruckenVertrieblerStatistik
            frmDruckenVertrieblerStatistik.VertriebmitarbeiterBindingSource.DataSource = bsDruckenVertriebler
            If frmDruckenVertrieblerStatistik.ShowDialog(Me) = DialogResult.OK Then
                frmDruckenVertrieblerStatistik.VertriebmitarbeiterBindingSource.EndEdit()
            Else
                frmDruckenVertrieblerStatistik.VertriebmitarbeiterBindingSource.CancelEdit()
            End If
        End Using
    End Sub




#End Region

End Class