﻿Imports System.Drawing.Printing
Imports Hartmann_Statistik.HartmannDts

Public Class dlgDruckenMonatsStatistik

    Private seitenZaehler As Integer
    Private benoetigteSeitenzahl As Integer
    Private actLine As Integer
    Private zeilenProSeite As Integer = 20

    Private _font As New Font("Segoe UI", 10)
    Private _fontBold As New Font("Segoe UI", 10, FontStyle.Bold)
    Private _fontHead As New Font("Segoe UI", 12)
    Private _fontSmall As New Font("Segoe UI", 8)
    Private _Brush As Brush = Brushes.Black
    Private LineHeight As Single = Me._font.GetHeight
    Private logo As Bitmap = My.Resources.LogoAGH

    Private Sub dlgDruckenMonatsStatistik_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ppc.Document = PrintDocument1
        PrintDocument1.DefaultPageSettings.Landscape = True
        For Each drucker As String In PrinterSettings.InstalledPrinters
            cboDrucker.Items.Add(drucker.ToString)
        Next
        cboDrucker.Text = PrintDocument1.PrinterSettings.PrinterName
        seitenzahlberechnen()
    End Sub

    Private Sub seitenzahlberechnen()
        Dim planCount As Integer = PlanBindingSource.Count - 1
        benoetigteSeitenzahl = CInt(Math.Ceiling(planCount / zeilenProSeite))
        If benoetigteSeitenzahl = 0 Then
            ppc.Rows = 1
        Else
            ppc.Rows = benoetigteSeitenzahl
        End If
    End Sub

    Private Sub PrintDocument1_BeginPrint(sender As Object, e As PrintEventArgs) Handles PrintDocument1.BeginPrint
        actLine = 0
        seitenZaehler = 1
    End Sub

    Private Sub PrintDocument1_PrintPage(sender As Object, e As PrintPageEventArgs) Handles PrintDocument1.PrintPage
        '
        'TODO Es werden noch nicht alle Zeilen korrekt gedruckt. zeilenProSeite <> Ausdruck
        '
        Dim g = e.Graphics

        Dim x As Single = e.MarginBounds.Left
        Dim y As Single = e.MarginBounds.Top
        PrintDocument1.DocumentName = "Hartmann Monatsstatistik Pläne vom " & dtpDruckenVon.Value.ToShortDateString & " bis " & dtpDruckenBis.Value.ToShortDateString
        g.DrawImage(logo, x + 900, y - 70, 130, 40)
        g.DrawString("Hygienepläne ...", _fontHead, _Brush, x - 70, y - 70)
        g.DrawString("Monatsstatistik Pläne vom " & dtpDruckenVon.Value.ToShortDateString & " bis " & dtpDruckenBis.Value.ToShortDateString, _font, _Brush, x - 70, y - 40)
        g.DrawString("Nr", _fontBold, _Brush, x - 70, y + 10)
        g.DrawString("Einstelldatum", _fontBold, _Brush, x - 40, y + 10)
        g.DrawString("Einrichtung", _fontBold, _Brush, x + 80, y + 10)
        g.DrawString("Bemerkung", _fontBold, _Brush, x + 390, y + 10)
        g.DrawString("Uploaddatum", _fontBold, _Brush, x + 810, y + 10)
        g.DrawString("VertriebMA", _fontBold, _Brush, x + 920, y + 10)
        g.DrawLine(Pens.Black, x - 70, y + 30, x + 1030, y + 30)
        Dim printedLines = 0
        For i = actLine To actLine + zeilenProSeite - 1
            If i >= PlanBindingSource.Count - 1 Then
                Exit For
            End If
            printedLines += 1
            Dim rwPlan = PlanBindingSource.At(Of PlanRow)(i)
            Dim rwVertriebler = rwPlan.VertriebmitarbeiterRow
            If rwPlan.berechnen = True Then
                g.DrawString(rwPlan.Nr.ToString, _font, _Brush, x - 70, y + 40)
                g.DrawString(rwPlan.Einstelldatum.ToShortDateString, _font, _Brush, x - 30, y + 40)
                g.DrawString(rwPlan.Einrichtungsname.ToString, _font, _Brush, x + 80, y + 40)
                g.DrawString(rwPlan.Bemerkung.ToString, _font, _Brush, x + 390, y + 40)
                g.DrawString(rwPlan.Uploaddatum.ToShortDateString, _font, _Brush, x + 820, y + 40)
                If Not rwVertriebler Is Nothing Then
                    g.DrawString(rwVertriebler.Name.ToString, _font, _Brush, x + 920, y + 40)
                Else
                    g.DrawString("keiner", _font, _Brush, x + 920, y + 40)
                End If
                y += LineHeight + 10
            End If
        Next
        actLine += printedLines
        g.DrawString("gedruckt am " & Date.Today.ToShortDateString & " um: " & DateTime.Now.ToShortTimeString, _fontSmall, _Brush, New Point(980, 800))
        g.DrawString(String.Format("Seite {0} von {1}", seitenZaehler, benoetigteSeitenzahl), _fontSmall, _Brush, New Point(20, 800))
        If seitenZaehler <= benoetigteSeitenzahl Then
            e.HasMorePages = True
            seitenZaehler += 1
        ElseIf actLine >= PlanBindingSource.Count - 1 Then
            e.HasMorePages = False
        End If

        'If actLine >= PlanBindingSource.Count - 1 Then
        '    e.HasMorePages = False
        'End If
    End Sub

    Private Sub btnDrucken_Click(sender As Object, e As EventArgs) Handles btnDrucken.Click
        PrintDocument1.Print()
    End Sub

    Private Sub dtpDrucken_CloseUp(sender As Object, e As EventArgs) Handles dtpDruckenVon.CloseUp, dtpDruckenBis.CloseUp
        PlanBindingSource.FilterX("Uploaddatum >= ? AND Uploaddatum <= ? ", dtpDruckenVon.Value, dtpDruckenBis.Value)
        ppc.InvalidatePreview()
        seitenzahlberechnen()
    End Sub

    Private Sub pnlDrucken_Paint(sender As Object, e As PaintEventArgs) Handles pnlDrucken.Paint
        e.Graphics.DrawLine(Pens.Black, pnlDrucken.Width - 1, 0, pnlDrucken.Width - 1, pnlDrucken.Height)
    End Sub

    Private Sub nudExemplare_ValueChanged(sender As Object, e As EventArgs) Handles nudExemplare.ValueChanged
        PrintDocument1.PrinterSettings.Copies = CShort(nudExemplare.Value)
    End Sub

    Private Sub cb_Drucken_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboDrucker.SelectedIndexChanged
        PrintDocument1.PrinterSettings.PrinterName = cboDrucker.SelectedItem.ToString
        ppc.Invalidate()
    End Sub

    Private Sub Zoom_Click(sender As Object, e As EventArgs) Handles btnZoomPlus.Click, btnZoomMinus.Click
        Select Case True
            Case sender Is btnZoomPlus : ppc.Zoom += 0.2
            Case sender Is btnZoomMinus : ppc.Zoom -= 0.2
        End Select
    End Sub

End Class