﻿Imports System.Drawing.Printing
Imports Hartmann_Statistik.HartmannDts

Public Class dlgDruckenVertrieblerStatistik

    Private rwVertriebler As VertriebmitarbeiterRow
    Private rwPlanCount As Integer

    'Private Sub DatenErmitteln()
    '    For i = 0 To VertriebmitarbeiterBindingSource.Count - 1
    '        rwVertriebler = VertriebmitarbeiterBindingSource.At(Of VertriebmitarbeiterRow)(i)
    '        rwPlanCount = rwVertriebler.GetPlanRows.Where(Function(f) f.Uploaddatum >= dtpDruckenVon.Value AndAlso f.Uploaddatum <= dtpDruckenBis.Value AndAlso f.erledigt = True AndAlso f.berechnen = True).Count
    '    Next
    'End Sub

    Public Sub PrintDocument1_PrintPage(sender As Object, e As PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim g = e.Graphics
        Dim _font = New Font("Segoe UI", 10)
        Dim _fontBold = New Font("Segoe UI", 10, FontStyle.Bold)
        Dim _fontHead = New Font("Segoe UI", 12)
        Dim _fontSmall = New Font("Segoe UI", 8)
        Dim _Brush = Brushes.Black
        Dim x As Single = e.MarginBounds.Left
        Dim y As Single = e.MarginBounds.Top
        Dim LineHeight As Single = _font.GetHeight(e.Graphics)
        Dim logo As Bitmap = My.Resources.LogoAGH
        PrintDocument1.DocumentName = "Hartmann Monatsstatistik Vertriebler vom " & dtpDruckenVon.Value.ToShortDateString & " bis " & dtpDruckenBis.Value.ToShortDateString
        g.DrawImage(logo, x + 570, y - 70, 130, 40)
        g.DrawString("Hygienepläne Hartmann, Bearbeitung C. Heinen, AGH Heinen", _fontHead, _Brush, x - 70, y - 70)
        g.DrawString("Monatsstatistik Vertriebler für " & dtpDruckenVon.Value.ToShortDateString & " bis " & dtpDruckenBis.Value.ToShortDateString, _font, _Brush, x - 70, y - 40)
        g.DrawString("Vertriebmitarbeiter", _fontBold, _Brush, x - 70, y + 10)
        g.DrawString("Anzahl Pläne", _fontBold, _Brush, x + 200, y + 10)
        g.DrawLine(Pens.Black, x - 70, y + 30, x + 700, y + 30)
        For i = 0 To VertriebmitarbeiterBindingSource.Count - 1
            rwVertriebler = VertriebmitarbeiterBindingSource.At(Of VertriebmitarbeiterRow)(i)
            rwPlanCount = rwVertriebler.GetPlanRows.Where(Function(f) f.Uploaddatum >= dtpDruckenVon.Value AndAlso f.Uploaddatum <= dtpDruckenBis.Value AndAlso f.erledigt = True AndAlso f.berechnen = True).Count
            g.DrawString(rwVertriebler.Name.ToString, _font, _Brush, x - 70, y + 40)
            g.DrawString(rwPlanCount.ToString, _font, _Brush, x + 200, y + 40)
            y += LineHeight + 10
        Next
        g.DrawString("gedruckt am " & Date.Today.ToShortDateString & " um: " & DateTime.Now.ToShortTimeString, _fontSmall, _Brush, New Point(640, 1140))

    End Sub

    Private Sub btnDrucken_Click(sender As Object, e As EventArgs) Handles btnDrucken.Click
        PrintDocument1.Print()
    End Sub

    Private Sub dlgDruckenMonatsStatistik_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'DatenErmitteln()
        ppc.Document = PrintDocument1
        ppc.Zoom = 0.8
        For Each drucker As String In PrinterSettings.InstalledPrinters
            cboDrucker.Items.Add(drucker.ToString)
        Next
        cboDrucker.Text = PrintDocument1.PrinterSettings.PrinterName
    End Sub

    Private Sub dtpDrucken_CloseUp(sender As Object, e As EventArgs) Handles dtpDruckenVon.CloseUp, dtpDruckenBis.CloseUp
        ppc.InvalidatePreview()
    End Sub

    Private Sub pnlDrucken_Paint(sender As Object, e As PaintEventArgs) Handles pnlDrucken.Paint
        e.Graphics.DrawLine(Pens.Black, pnlDrucken.Width - 1, 0, pnlDrucken.Width - 1, pnlDrucken.Height)
    End Sub

    Private Sub nudExemplare_ValueChanged(sender As Object, e As EventArgs) Handles nudExemplare.ValueChanged
        PrintDocument1.PrinterSettings.Copies = CShort(nudExemplare.Value)
    End Sub

    Private Sub cb_Drucken_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboDrucker.SelectedIndexChanged
        PrintDocument1.PrinterSettings.PrinterName = cboDrucker.SelectedItem.ToString
        ppc.Invalidate()
    End Sub

    Private Sub Zoom_Click(sender As Object, e As EventArgs) Handles btnZoomPlus.Click, btnZoomMinus.Click
        Select Case True
            Case sender Is btnZoomPlus : ppc.Zoom += 0.2
            Case sender Is btnZoomMinus : ppc.Zoom -= 0.2
        End Select
    End Sub
End Class