﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics

Namespace System.Collections.Generic
   <ComponentModel.EditorBrowsable(ComponentModel.EditorBrowsableState.Never)> _
   Public Module CollectionX

      ''' <summary>returns the **typed** Array-Enumerator </summary>
      <Extension(), DebuggerStepThrough()> _
      Public Function GetEnumeratorX(Of T)(ByVal subj As T()) As IEnumerator(Of T)
         Return DirectCast(subj, IList(Of T)).GetEnumerator
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function FindIndex(Of T)(ByVal Arr() As T, ByVal IsMatch As Predicate(Of T)) As Integer
         Return Array.FindIndex(Arr, IsMatch)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function Find(Of T)(ByVal Arr() As T, ByVal IsMatch As Predicate(Of T)) As T
         Return Array.Find(Arr, IsMatch)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function IndexOf(Of T)(ByVal Arr() As T, ByVal Element As T) As Integer
         Return Array.IndexOf(Arr, Element)
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Sub ForEach(Of T)(ByVal items As T(), ByVal Action As Action(Of T))
         Array.ForEach(items, Action)
      End Sub
      <DebuggerStepThrough(), Extension()> _
      Public Sub ForEach(Of T)(ByVal items As IEnumerable(Of T), ByVal Action As Action(Of T))
         For Each itm In items
            Action(itm)
         Next
      End Sub

      <Extension()> _
      Public Function GetOrCreate(Of Tkey, Tvalue As New)( _
    ByVal subj As Dictionary(Of Tkey, Tvalue), ByVal key As Tkey) As Tvalue
         Dim ret As Tvalue
         If Not subj.TryGetValue(key, ret) Then
            ret = New Tvalue
            subj.Add(key, ret)
         End If
         Return ret
      End Function

   End Module

End Namespace
