﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.ComponentModel

Namespace System
   <EditorBrowsable(EditorBrowsableState.Never)> _
   Public Module ObjectX

      ''' <summary>trycast value to desired Type and assigns it.</summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function TryBe(Of T As Class)(ByRef target As T, ByVal value As Object) As Boolean
         Dim x = TryCast(value, T)
         If x Is Nothing Then Return False
         target = x
         Return True
      End Function
      ''' <summary>cast value to desired Type and assigns it. Causes InvalidCastException on failure</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Sub Be(Of T)(ByRef target As T, ByVal value As Object)
         target = DirectCast(value, T)
      End Sub
      ''' <summary>create target by creater if null. then return it</summary>
      <Extension()> _
      Public Function CreateLazy(Of T)(ByRef target As T, ByVal creater As Func(Of T)) As T
         If target Is Nothing Then target = creater()
         Return target
      End Function

      <DebuggerStepThrough()>
      <Extension()> _
      Public Function CloneX(Of T As ICloneable)(ByVal Obj As T) As T
         Return DirectCast(Obj.Clone(), T)
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function Null(Of T As Class)(ByVal Subj As T) As Boolean
         Return Subj Is Nothing
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function NotNull(Of T As Class)(ByVal Subj As T) As Boolean
         Return Subj IsNot Nothing
      End Function

   End Module
End Namespace
