﻿Option Compare Text

Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.Collections
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports System.ComponentModel

Namespace System

   Public Module StringX

      <EditorBrowsable(EditorBrowsableState.Never)> _
      Public Function ReplaceBslashN(s As String) As String
         Dim sb As New StringBuilder
         For i = 0 To s.Length - 2 Step 2
            If s.IndexOf("\n", i, 2) < 0 Then Exit For
            sb.Append(CrLf)
         Next
         sb.Append(s.Substring(sb.Length))
         Return sb.ToString
      End Function

      '''<summary> verkettet alles, interpretiert \n am Anfang als newline</summary>
      <Extension()> _
      Public Function And2(Subj As String, ParamArray others() As Object) As String
         Dim sb = New StringBuilder(ReplaceBslashN(Subj))
         For Each itm In others
            sb.Append(ReplaceBslashN(itm.ToString))
         Next
         Return sb.ToString
      End Function

      ''' <returns>den Stringabschnitt ab dem letzten Auftreten von sMatch (ohne sMatch)</returns>
      <Extension()> _
      Public Function LastRightCut(s As String, sMatch As String) As String
         Dim i = s.LastIndexOf(sMatch)
         If i < 0 Then Return Nothing
         Return s.Substring(i + sMatch.Length)
      End Function

      ''' <returns>den Stringabschnitt ab dem ersten Auftreten von sMatch (ohne sMatch)</returns>
      <Extension()> _
      Public Function RightCut(S$, sMatch$) As String
         Dim I% = S.IndexOf(sMatch)
         If I < 0 Then Return Nothing
         Return S.Substring(I + sMatch.Length)
      End Function

      ''' <summary>gibt den String-Abschnitt links des ersten gefundenen Matches zurück</summary>
      <Extension()> _
      Public Function LastLeftCut(Subj As String, Pattern As String) As String
         Dim i = Subj.LastIndexOf(Pattern)
         Return If(i >= 0, Subj.Remove(i), Nothing)
      End Function

      ''' <summary>
      ''' gibt den String-Abschnitt links des ersten gefundenen Matches zurück
      ''' </summary>
      <Extension()> _
      Public Function LeftCut(Subj As String, Pattern As String) As String
         Dim i = Subj.IndexOf(Pattern)
         Return If(i >= 0, Subj.Remove(i), Nothing)
      End Function

      Public Enum Additional : None : Start : [End] : Start_End : End Enum
      <Extension()> _
      Public Function Between(separator As Char, additional As Additional, ParamArray args() As Object) As String
         Return Between(args, separator, additional)
      End Function
      <Extension()> _
      Public Function Between(separator As Char, ParamArray args() As Object) As String
         Return Between(args, separator, Additional.None)
      End Function
      <Extension()> _
      Public Function Between(separator As String, additional As Additional, ParamArray args() As Object) As String
         Return Between(args, separator, additional)
      End Function
      <Extension()> _
      Public Function Between(separator As String, ParamArray args() As Object) As String
         If args.Length = 1 Then
            'special: args is just 2 chars in a string - treat the chars as opening and closing bracket or Quotes
            Dim s As String = TryCast(args(0), String)
            If s.NotNull AndAlso s.Length = 2 Then Return String.Concat(s(0), separator, s(1))
         End If
         Return Between(args, separator, Additional.None)
      End Function

      Private _SB As New System.Text.StringBuilder
      Private Function Between(args() As Object, separator As String, additional As Additional) As String
         Try
            While args.Length < 2 AndAlso Not TypeOf args(0) Is String
               args = DirectCast(args(0), IEnumerable).Cast(Of Object).ToArray
            End While
         Catch ex As Exception ' can be InvalidCast or IndexOutOfRange
         End Try
         _SB.Clear()
         If additional.HasFlag(additional.Start) Then _SB.Append(separator)
         _SB.Append(String.Join(separator, args))
         If additional.HasFlag(additional.End) Then _SB.Append(separator)
         Return _SB.ToString
      End Function

   End Module


End Namespace